import pygame, time, sys
import serial, OSC



pygame.mixer.init()
pygame.mixer.pre_init(44100, -16, 2, 65536)
pygame.init()

pygame.display.set_mode((200, 200))
pygame.display.set_caption("carte")

SONG_END = pygame.USEREVENT +1
pygame.mixer.music.set_endevent(SONG_END)

ser = serial.Serial('/dev/ttyUSB0', 9600)
client = OSC.OSCClient()
msg = OSC.OSCMessage()
msg.setAddress("/fromserial")

valuepreviousa = '00'
valuepreviousb = '00'

##-----------------------------------------------------------
def arduinoIDreadA (path, fade):

    global valuepreviousa

    c1 = pygame.mixer.Channel(1)
    soundfileID = '00'

        
    if serialValue[1] != '9':
        if serialValue[2] == '1':
            soundfileID = str(serialValue[1]) + str(serialValue[3]) 
            if soundfileID != valuepreviousa :
                print ('a' + soundfileID)
                msg.append('a' + soundfileID[0] + '1' + soundfileID[1])
                client.sendto(msg, ('192.168.1.48', 9000))
                msg.clearData()
                soundfile = path + 'carte' + str(serialValue[1]) + str(serialValue[3]) + '.aif'                                                              
                s1 = pygame.mixer.Sound(soundfile)
                c1.play(s1, 0, 0, 0)
                c1.set_volume(1)
                if c1.get_busy() == True:
                    valuepreviousa = soundfileID

    if serialValue[1] == '9':
    	if valuepreviousa != soundfileID :
        	c1.fadeout(fade)  
	    	msg.append('a900')
    		print ('a900')
        	client.sendto(msg, ('192.168.1.48', 9000))
	        msg.clearData()
	        valuepreviousa = '00'                    

##-----------------------------------------------------------   
def arduinoIDreadB (path, fade):

    global valuepreviousb

    c2 = pygame.mixer.Channel(2)
    soundfileID = '00'
        
    if serialValue[1] != '9':
        if serialValue[2] == '1':
            soundfileID = str(serialValue[1]) + str(serialValue[3]) 
            if soundfileID != valuepreviousb :
                print ('b' + soundfileID)
            	msg.append('b' + soundfileID[0] + '1' + soundfileID[1])
                client.sendto(msg, ('192.168.1.48', 9000))
                msg.clearData()
                soundfile = path + 'carte' + str(serialValue[1]) + str(serialValue[3]) + '.aif'                                                              
                s2 = pygame.mixer.Sound(soundfile)
                c2.play(s2, 0, 0, 0)
                c2.set_volume(1)
                if c2.get_busy() == True:
                    valuepreviousb = soundfileID  

    if serialValue[1] == '9':
    	if valuepreviousb != soundfileID :
        	c2.fadeout(fade)  
        	msg.append('b900')
        	print('b900')
        	client.sendto(msg, ('192.168.1.48', 9000))
        	msg.clearData()
        	valuepreviousb = '00'
##-----------------------------------------------------------   
mainloop = True
while mainloop:
	serialValue = ser.readline().strip().strip('').strip('\n')

	if len(serialValue) == 4:
	    if serialValue[0] == 'a':
	        arduinoIDreadA("/home/pi/toutisons/", 1000)
	    if serialValue[0] == 'b':
	        arduinoIDreadB("/home/pi/toutisons/", 1000)    
     
    
	for event in pygame.event.get():
             if event.type == pygame.KEYDOWN:
                            if event.key == pygame.K_ESCAPE:
                                pygame.mixer.fadeout(1000)
                                pygame.display.flip()
                                time.sleep(1)
                                ser.close()
                                time.sleep(1)
                                pygame.quit()
                                sys.exit()                                
                                pygame.mixer.music.fadeout(1000)

             
        

